#ifndef BASE_OBJECT_H
#define BASE_OBJECT_H

#include "CrashTestDLL.h"

#include <string>
#include <boost/shared_ptr.hpp>
#include <boost/serialization/access.hpp>
#include <boost/serialization/export.hpp>
#include <boost/serialization/tracking.hpp>
#include <boost/serialization/extern.hpp>

class BaseObject;
typedef boost::shared_ptr<BaseObject> BaseObjectPtr;

class CRASHTESTDLL_API BaseObject
{
public:
    BaseObject(size_t n=10);
    virtual ~BaseObject();

    template <typename Archive>
    friend void serialize( Archive & ar, BaseObject & obj, const unsigned int file_version );
    friend class boost::serialization::access;

private:
    size_t m_size;
};

BOOST_CLASS_EXPORT_KEY2(BaseObject, "BaseObject")
BOOST_CLASS_TRACKING(BaseObject, boost::serialization::track_always)

namespace boost { namespace archive { class xml_iarchive; class xml_oarchive; } }

BOOST_SERIALIZATION_EXTERN_ISERIALIZER(boost::archive::xml_iarchive, BaseObject, CRASHTESTDLL_API)
BOOST_SERIALIZATION_EXTERN_OSERIALIZER(boost::archive::xml_oarchive, BaseObject, CRASHTESTDLL_API)

#endif
