#include "TestObject.h"

#include <boost/serialization/nvp.hpp>
#include <boost/serialization/shared_ptr.hpp>
#include <boost/archive/xml_iarchive.hpp>
#include <boost/archive/xml_oarchive.hpp>

TestObject::TestObject(size_t n)
: BaseObject(n)
{}

TestObject::TestObject(BaseObjectPtr const & object)
: m_object(object)
{}

TestObject::~TestObject()
{}

template <typename Archive>
void serialize( Archive & ar, TestObject & obj, const unsigned int /*file_version*/ )
{
    ar & boost::serialization::make_nvp("BaseObject", boost::serialization::base_object<BaseObject>(obj));
    ar & boost::serialization::make_nvp( "m_object", obj.m_object );
}

template CRASHTESTDLL_API void serialize<boost::archive::xml_oarchive>( boost::archive::xml_oarchive& ar, TestObject & obj, const unsigned int file_version );
template CRASHTESTDLL_API void serialize<boost::archive::xml_iarchive>( boost::archive::xml_iarchive& ar, TestObject & obj, const unsigned int file_version );

BOOST_CLASS_EXPORT_IMPLEMENT(TestObject)
BOOST_SERIALIZATION_INSTANTIATE_ISERIALIZER(boost::archive::xml_iarchive, TestObject, CRASHTESTDLL_API)
BOOST_SERIALIZATION_INSTANTIATE_OSERIALIZER(boost::archive::xml_oarchive, TestObject, CRASHTESTDLL_API)
